dossieraid/urls.py
from django.contrib import admin
from django.conf.urls import url
from django.urls import include, path
from material.frontend import urls as frontend_urls
from django.conf import settings
from django.conf.urls.static import static
from django.contrib.auth.views import password_reset_confirm
from dossieraid.secure_dowload import  dl_file
urlpatterns = [
    url(r'', include(frontend_urls)),
    url(r'admin/', admin.site.urls),
    url(r'^accounts/password/reset/(?P<uidb64>[0-9A-Za-z]+)-(?P<token>.+)/$',
        password_reset_confirm, name='password_reset_confirm'),
    path('accounts/', include('django.contrib.auth.urls')),
    url(r'^orga/', include('orga.urls')),
    url(r'^', include('gestion.urls')),
    url(r'^media/(?P<path>.+)', dl_file), #délègue le téléchargement à Django-Sendfile
]

orga/urls.py
from django.conf.urls import url
from orga.views import *
from django.views.decorators.http import require_POST
urlpatterns = [
    url(r'^$', InterfaceAdmin.as_view()),
    url(r'^liste/$', ListeParticipants.as_view()),
    url(r'^add/(?P<pk>[0-9]+)/', RajoutParticipant.as_view()),
    url(r'^edit/(?P<pk>[0-9]+)/$', EditeParticipant.as_view()),
    url(r'^equipe/$', RajoutEquipe.as_view()),
    url(r'^tableau/$', TableauParticipants.as_view()),
    url(r'^valide/(?P<pk>[0-9]+)/$', ValideParticipantView.as_view()),
    url(r'^payed/all$', check_all_paiements),
    url(r'^payed/(?P<pk>[0-9]+)/$', check_paiements),
    url(r'^prevente/add$', ParticipantPreventeView.as_view()),
    url(r'^prevente/$', PreventeListeView.as_view()),
    url(r'^billevent/(?P<pk>[0-9]+)$', create_billevent),
    url(r'^sendlink/(?P<id>[0-9]+)$', sendlink),

]

gestion/models.py
from django.db import models
from django.core.validators import RegexValidator
from django.contrib.auth.models import User
from django.urls import reverse
from gestion.email import InvitationEmail
from gestion.validate_pdf import validate_pdf
from django.core.signing import Signer
# Create your models here.

EQUIPE_STATUS = (
    (0, 'Non complète'),
    (1, 'Pas validé'),
    (2, 'Annulée'),
    (3, 'Validée/Inscrite'),
    (4, 'Refusée')
)


class Equipe(models.Model):
    class Meta:
        verbose_name = 'Équipe'

    nom_equipe = models.CharField(max_length=255, verbose_name='Nom de l\'équipe', unique=True)
    status = models.IntegerField(choices=EQUIPE_STATUS, verbose_name='Status de l\'équipe', default=0)

    @property
    def nombre_participants(self):
        return self.participants.filter(status__lt=2).count() #compte uniquement les participants non refusés et non  désistés

    @property
    def est_valide(self):
        if self.nombre_participants == 4 and self.status == 3:
            return True
        else:
            return False

    def __str__(self):
        return ' # ' + str(self.id) + ' ' + self.nom_equipe + ', ' + str(self.nombre_participants) + ' membres'

    @property
    def for_email(self):
        return str(self.nom_equipe)

PARTICIPANT_STATUS = (
    (0, 'Pas validé'),
    (1, 'Valide'),
    (2, 'Paiement en cours'),
    (3, 'Inscrit, paiement effectué'),
    (4, 'Désisté'),  # annulation pour cause de maladie
    (5, 'Refusé')    #annulé par l'Orga
)
SEXE = (
    (0, 'Unspecified'),
    (1, 'Homme'),
    (2, 'Femme'),
)

TAILLE_TSHIRT = (
    ('S','S'),
    ('M','M'),
    ('L','L'),
    ('XL','XL')
)

class Participant(models.Model):
    class Meta:
        verbose_name = 'Participant'

    prenom = models.CharField(max_length=255, verbose_name='Prénom')
    nom = models.CharField(max_length=255, verbose_name='Nom')
    user = models.OneToOneField(User, on_delete=models.PROTECT, null=True)
    telephone_regex = RegexValidator(regex=r'^\+?1?\d{9,15}$',
                                     message="Phone number must be entered in the format: '+999999999'. Up to 15 digits allowed.")
    telephone_number = models.CharField(validators=[telephone_regex], max_length=17,
                                        verbose_name="Numéro de téléphone")  # validators should be a list
    anniv = models.DateField(verbose_name='Date de naissance')
    sexe = models.IntegerField(choices=SEXE, default=0)
    taille = models.IntegerField(verbose_name='Taille (cm)')
    taille_Tshirt = models.CharField(verbose_name='Taille de T-shirt', max_length=255, choices=TAILLE_TSHIRT)
    email = models.EmailField(max_length=255)
    status = models.IntegerField(choices=PARTICIPANT_STATUS, verbose_name='Status participant', default=0)
    a_paye = models.BooleanField(verbose_name='Paiement effectué', default=False)
    paiement_prevente = models.BooleanField(verbose_name="A payé lors d'une prévente", default=False)
    equipe = models.ForeignKey(to=Equipe, related_name='participants', on_delete=models.CASCADE, verbose_name='Équipe',
                               null=True)
    is_leader = models.BooleanField(verbose_name='A créé son équipe', default=False)
    # validation des documents
    def upload_participant_resp_civile(self, filename):
        return 'uploads/part_{0}/resp_civile/{1}'.format(self.id, filename)
    def upload_participant_certif_medic(self, filename):
        return 'uploads/part_{0}/certif_medic/{1}'.format(self.id, filename)
    def upload_participant_decharge_resp(self, filename):
        return 'uploads/part_{0}/decharge_resp/{1}'.format(self.id, filename)
    def upload_participant_carte_edu(self, filename):
        return 'uploads/part_{0}/carte_edu/{1}'.format(self.id, filename)
    resp_civile_valide = models.BooleanField(verbose_name='Attestation de reponsabilité civile validée', default=False)
    resp_civile_prevente = models.BooleanField(verbose_name='Attestation de reponsabilité civile donnée à la prévente', default=False)
    resp_civile = models.FileField(upload_to=upload_participant_resp_civile, verbose_name='Attestation de responsabilité civile',
                                   blank=True, validators=[validate_pdf])
    certif_medic_valide = models.BooleanField(verbose_name='Certificat médical validé', default=False)
    certif_medic_prevente = models.BooleanField(verbose_name='Certificat médical donnée à la prévente', default=False)
    certif_medic = models.FileField(upload_to=upload_participant_certif_medic,
                                    verbose_name='Certificat médical de non contre-indication à la pratique du raid multisport en compétition.',
                                    blank=True, validators=[validate_pdf])
    decharge_resp_valide = models.BooleanField(verbose_name='Décharge de responsabilité  signée', default=False)
    decharge_resp_prevente = models.BooleanField(verbose_name='Décharge de responsabilité donnée à la prévente', default=False)
    decharge_resp = models.FileField(upload_to=upload_participant_decharge_resp,
                                     verbose_name='Décharge (autorisation photo, nage, accord avec le règlement)',
                                     blank=True, validators=[validate_pdf])
    carte_edu_valide = models.BooleanField(verbose_name='Carte Étudiante validée(pas forcément INSA)', default=False)
    carte_edu_prevente = models.BooleanField(verbose_name='Preuve de carte étudiante donnée à la prévnte', default=False)
    carte_edu = models.FileField(upload_to=upload_participant_carte_edu, verbose_name='Preuve de carte étudiante',
                                 blank=True, validators=[validate_pdf])

    #etudiant_valide = models.BooleanField(verbose_name='Status étudiant validé', default=False)
    #etudiant_insa = models.BooleanField(verbose_name='Étudie (vraiment) à l\'INSA', default=False)
    DEPARTEMENTS = (('PC', 'Premier Cycle'), ('IF', 'Informatique'), ('TC', 'Télécom'),
                                            ('GM', 'Génie Mécanique'), ('SGM', 'Science et Génie des Matériaux'),
                                            ('GI', 'Génie Industriel'), ('BS', 'Biosciences'),
                                            ('GE', 'Génie Éléctrique'),
                                            ('GCU', 'Génie Civil et Urbanisme'),
                                            ('GEN', 'Génie Énergétique et Environnement'),
                                            ('EXT', "N'est pas à l'INSA"))
    departement = models.CharField(choices=DEPARTEMENTS, max_length=3,
                                   verbose_name='Département', default='EXT')
    ANNEES = [(0, 'Extérieur'), (1, '1A'), (2, '2A'), (3, '3A'), (4, '4A'), (5, '5A')]
    annee = models.IntegerField(choices=ANNEES,
                                verbose_name='Année d\'études', default=0)
    numero_VA = models.CharField(verbose_name='Numéro de carte VA si applicable', null=True, blank=True, max_length=255)
    va_valide = models.BooleanField(verbose_name='Carte VA valide', default=False)
    divers = models.CharField(verbose_name="Remarques, régime alimentaire parituculier ..", max_length=2000, blank=True)
    client_id = models.IntegerField(verbose_name="ID de client sur Billevent", null=True, blank=True)
    invitation_id = models.IntegerField(verbose_name="ID du lien d'invitation sur billevent", null=True, blank=True)
    invitation_link_sent = models.BooleanField(verbose_name="Lien de paiement envoyé", default=False)

    def __str__(self):
        return '#' + str(self.id) + ' ' + self.nom + ' ' + self.prenom + ', équipe (' + str(
            self.equipe.id) + ') ' + self.equipe.nom_equipe

    @property
    def nom_prenom(self):
        return str(self.prenom) + ' ' + str(self.nom)

    @property
    def status_verbose(self):
        return PARTICIPANT_STATUS[self.status][1]
    @property
    def va_ou_edu_valide(self):
        if self.va_valide: return 'VA'
        elif self.carte_edu_valide: return 'Edu'
        else: return 'Normal'
    @property
    def niveau_etudes(self):
        if self.annee !=0 and self.departement != 'EXT':
            return self.ANNEES[self.annee][1]+' '+ self.departement
        else:
            return 'Ext.'
    @property
    def sexe_verbose(self):
        return SEXE[self.sexe][1]

    @property
    def resp_civile_exist(self):
        if self.resp_civile:
            if self.resp_civile_valide: return 'Valide'
            else: return 'En ligne'
        elif self.resp_civile_prevente:
            if self.resp_civile_valide: return 'Valide'
            else: return 'Prévente'
        else: return ''

    @property
    def certif_medic_exist(self):
        if self.certif_medic:
            if self.certif_medic_valide: return 'Valide'
            else: return 'En ligne'
        elif self.certif_medic_prevente:
            if self.certif_medic_valide: return 'Valide'
            else: return 'Prévente'
        else: return ''

    @property
    def decharge_resp_exist(self):
        if self.decharge_resp:
            if self.decharge_resp_valide: return 'Valide'
            else: return 'En ligne'
        elif self.decharge_resp_prevente:
            if self.decharge_resp_valide: return 'Valide'
            else: return 'Prévente'
        else: return ''

    @property
    def carte_edu_exist(self):
        if self.carte_edu:
            if self.carte_edu_valide: return 'Valide'
            else: return 'En ligne'
        elif self.carte_edu_prevente:
            if self.carte_edu_valide: return 'Valide'
            else: return 'Prévente'
        else: return ''
    @property
    def paiement_valide(self):
        if self.a_paye : return 'Billetterie'
        elif self.paiement_prevente: return 'Prévente'
        else: return 'Non'
    def prix_type(self):
        if self.va_ou_edu_valide == 'VA': return 'prixVA'
        elif self.va_ou_edu_valide == 'Edu': return 'prixEdu'
        else: return 'prixNormal'

orga/models.py
from django.db import models

# Create your models here.

orga/forms.py
from django.forms import ModelForm
from gestion.models import Participant

class ParticipantForm(ModelForm):
    class Meta:
        model = Participant
        exclude = ['user', 'a_paye', 'client_id', 'invitation_id', 'invitation_link_sent']

class ValideParticipantForm(ModelForm):
    class Meta:
        model = Participant
        fields = ['a_paye', 'resp_civile_valide', 'certif_medic_valide',
                  'decharge_resp_valide',
                  'va_valide',
                  'carte_edu_valide']

class PreventeParticipantForm(ModelForm):
    class Meta:
        model = Participant
        exclude = ['user', 'a_paye', 'client_id', 'invitation_id', 'invitation_link_sent', 'is_leader', #'etudiant_insa',
                   'resp_civile', 'certif_medic', 'decharge_resp', 'carte_edu', 'numero_VA',
                   'resp_civile_valide', 'certif_medic_valide', 'carte_edu_valide', 'decharge_resp_valide']

orga/templates/admin.html
{% extends 'base.html' %}
{% block content %}
<h1>Bienvenue sur l'interface d'administration du RAID</h1>
    <!--<div class="card-panel teal lighten-2">-->
    <a class="btn pulse" href="/orga/prevente/">Préventes</a>
        <div class="card-panel green lighten-1"><a class="btn waves-effect waves-light" href="equipe/">Rajouter une équipe</a> Pour créer une nouvelle équipe. Il faudra ensuite rajouter des participants.</div>
        <div class="card-panel blue lighten-2"><a class="btn waves-effect waves-light" href="liste/">Modifier et rajouter des participants</a> Vous pouvez modifier les informations remplies par les participants eux-mêmes.<br>Si vous rajoutez un participant à la main, il ne pourra pas se connecter lui-même.</div>
        <div class="card-panel yellow lighten-1"><a class="btn waves-effect waves-light" href="tableau/">Voir le tableau des participants</a> Ici, vous pouvez voir et valider les infos et documents mis en ligne par les participants</div>
    <div class="card-panel red lighten-3">
    <a class="btn" href="/orga/payed/all">Synchroniser la billetterie</a> Met à jour tous les paiements pour les participant ayant commencé à payer
    </div>
{% endblock %}

orga/templates/liste_equipes.html
{% extends 'base.html' %}
{% block content %}
<div>
    {% for equipe in object_list %}
        <div class="card-panel blue lighten-2 hoverable row">
        <div class="col l4 s12 m5"><h5>{{ equipe.for_email }}</h5></div>
        <div class="col l8 m7 s12"> <a href="../add/{{ equipe.id }}/" class="btn">Rajouter un membre</a>
    <table class="striped"><tbody>{% for participant in equipe.participants.all %}
        <tr><td>{{ participant.nom_prenom }}</td><td>{{ participant.status_verbose }}</td>
        <td><a class="btn" href="../edit/{{ participant.id }}/">Modifier</a></td></tr>
    {% endfor %}</tbody></table>
        </div>
        </div>
    {% endfor %}
</div>
{% endblock %}

orga/templates/tableau_participants.html
{% extends 'base.html' %}
{% block large-content %}
    <table class="striped bordered responsive-table">
        <thead>
        <tr>
            <th>Prénom Nom</th>
            <th>Équipe</th>
            <th>Sexe</th>
            <th>Numéro</th>
            <th>Date de naissance</th>
            <th>Taille(cm)</th>
            <th>Taille <br>T-shirt</th>
            <th>E-mail</th>
            <th>Tarif</th>
            <th>Status</th>
            <th>Départ.</th>
            <th>Attestation<br> de resp.</th>
            <th>Certificat<br>médical</th>
            <th>Décharge</th>
            <th>Carte Edu</th>
            <th>Infos diverses</th>
            <th>Payé ?</th>
        </tr>
        </thead>
    {% for participant in participants %}
    <tr>
        <td><a href="../edit/{{ participant.id }}/">{{ participant.nom_prenom }}</a></td>
        <td>#{{ participant.equipe.id }} {{ participant.equipe.nom_equipe }}</td>
        <td>{{ participant.sexe_verbose }}</td>
        <td>{{ participant.telephone_number }}</td>
        <td>{{ participant.anniv }}</td>
        <td>{{ participant.taille }}</td>
        <td>{{ participant.taille_Tshirt }}</td>
        <td>{{ participant.email }}</td>
        <td>{{ participant.va_ou_edu_valide }}</td>
        <td><a href="/orga/valide/{{ participant.id }}/">{{ participant.status_verbose }}</a></td>
        <td>{{ participant.niveau_etudes }}</td>
        <td>{{ participant.resp_civile_exist }}</td>
        <td>{{ participant.certif_medic_exist }}</td>
        <td>{{ participant.decharge_resp_exist }}</td>
        <td>{{ participant.carte_edu_exist }}</td>
        <td>{{ participant.divers }}</td>
        <td>{{ participant.paiement_valide }}</td>
    </tr>
    {% endfor %}</tbody>
    </table>
{% endblock %}

orga/templates/tableau_prevente.html
{% extends 'base.html' %}
{% block large-content %}
<div class="card-panel grey lighten-1">
<a class="btn" href="add">Rajouter des participants</a>
<a class="btn" href="/orga/equipe">Rajouter une équipe</a>
</div>
    <table class="striped bordered responsive-table">
        <thead>
        <tr>
            <th>Prénom Nom</th>
            <th>Équipe</th>
            <th>Sexe</th>
            <th>Numéro</th>
            <th>Date de naissance</th>
            <th>Taille(cm)</th>
            <th>Taille <br>T-shirt</th>
            <th>E-mail</th>
            <th>Tarif</th>
            <th>Status</th>
            <th>Départ.</th>
            <th>Attestation<br> de resp.</th>
            <th>Certificat<br>médical</th>
            <th>Décharge</th>
            <th>Carte Edu</th>
            <th>Infos diverses</th>
            <th>Payé ?</th>
        </tr>
        </thead>
    <tbody>
    {% for participant in participants %}
    <tr>
        <td><a href="../edit/{{ participant.id }}/">{{ participant.nom_prenom }}</a></td>
        <td>#{{ participant.equipe.id }} {{ participant.equipe.nom_equipe }}</td>
        <td>{{ participant.sexe_verbose }}</td>
        <td>{{ participant.telephone_number }}</td>
        <td>{{ participant.anniv }}</td>
        <td>{{ participant.taille }}</td>
        <td>{{ participant.taille_Tshirt }}</td>
        <td>{{ participant.email }}</td>
        <td>{{ participant.va_ou_edu_valide }}</td>
        <td><a href="/orga/valide/{{ participant.id }}/?next=/orga/prevente/">{{ participant.status_verbose }}</a></td>
        <td>{{ participant.niveau_etudes }}</td>
        <td>{{ participant.resp_civile_exist }}</td>
        <td>{{ participant.certif_medic_exist }}</td>
        <td>{{ participant.decharge_resp_exist }}</td>
        <td>{{ participant.carte_edu_exist }}</td>
        <td>{{ participant.divers }}</td>
        <td>{{ participant.paiement_valide }}</td>
    </tr>
    {% endfor %}</tbody>
    </table>
{% endblock %}

orga/templates/valide_participant.html
{% extends 'base.html' %}
{% load material_form %}
{% block content %}
    <div class="card-panel green"><h3 style="display: inline">{{ participant.nom_prenom }}</h3> équipe <h4
            style="display: inline">{{ participant.equipe }}</h4></div>
    <div class="card-panel lime lighten-1">
        <ul>
            <li>{% if participant.resp_civile %}
                Attestation de responsabilité civile
                <a href="{{ participant.resp_civile.url }}">{{ participant.resp_civile }}</a>
            {% else %}
                Attestation de responsabilité civile manquante
            {% endif %}
            </li>
            <li>
                {% if participant.certif_medic %}
                    Certificat médial <a href="{{ participant.certif_medic.url }}">{{ participant.certif_medic }}</a>
                {% else %}
                    Certificat médial manquant
                {% endif %}
            </li>
            <li>
                {% if participant.decharge_resp %}
                    Décharge <a href="{{ participant.decharge_resp.url }}">{{ participant.decharge_resp }}</a>
                {% else %}
                    Décharge manquant
                {% endif %}
            </li>
            <li>
                {% if participant.carte_edu %}
                    Preuve de carte étudiante <a href="{{ participant.carte_edu.url }}">{{ participant.carte_edu }}</a>
                {% elif participant.va_valide %}
                    Carte VA vérifiée : {{ participant.numero_VA }}
                {% else %}
                    Preuve de carte étudiante manquante. Carte VA N°{{ participant.numero_VA }} (si renseigné)
                {% endif %}
            </li>
        </ul>
        A payé :{{ participant.paiement_valide }}
        {% if participant.status == 2 %}<a href="/orga/payed/{{ participant.id }}/" class="btn">
            Vérifier le paiement sur billevent</a>{% endif %}
    </div>
    <div class="teal lighten-3 card-panel">
        <form method="POST" class="post-form" enctype="multipart/form-data" onSubmit="return verif()">
            {% csrf_token %}
            {% form form=form %}{% endform %}
            <button name="_submit" type="submit" class="save btn waves-effect waves-light" id="sauvegarder">
                Sauvegarder
            </button>
        </form>
    </div>
    <script>
        function verif() {
            //$('#ret').text($("select option:selected").val());
            var e = $("select option:selected").val();
            //Si le mec a séléctionné Valide
            var a = $("#id_resp_civile_valide").prop('checked');
            var b = $("#id_certif_medic_valide").prop('checked');
            var c = $("#id_decharge_resp_valide").prop('checked');
            //var d = $("#id_carte_edu_valide").prop('checked');
            //l'état des cases
            //$('#ret').text("VALIDE"+a+b);
            if ((a == false || b == false || c == false /*|| d == false*/) && e == "1") { //si le mec a validé le participant sans
                return confirm("Tous les documents du participant n'ont pas été validés !\n Voulez-vous continuer ?")  // que tous les documents soient vérifiés
            }
            //else{ return true}

        }
    </script>
    </script>
{% endblock %}